;;This file is part of Elfo saves Christmas.

    ;;Elfo saves Christmas is free software: you can redistribute it and/or modify
    ;;it under the terms of the GNU General Public License as published by
    ;;the Free Software Foundation, either version 3 of the License, or
    ;;(at your option) any later version.

    ;;Elfo saves Christmas is distributed in the hope that it will be useful,
    ;;but WITHOUT ANY WARRANTY; without even the implied warranty of
    ;;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    ;;GNU General Public License for more details.

    ;;You should have received a copy of the GNU General Public License
    ;;along with Elfo saves Christmas.  If not, see <https://www.gnu.org/licenses/>.

;;
;;  Macros
;;
.macro DefineDrawableEntity _name, _x, _y, _w, _h, _sp
_name:
    DefineDrawableEntity_Simple _name'_simple, _x, _y, _w, _h
    .dw _sp
_name'_size = . - _name
.endm

.macro DefineDrawableEntity_Simple _name, _x, _y, _w, _h
_name:
    .db _x, _y
    .db _w, _h
_name'_size = . - _name
.endm

de_simple_size = 4

;; Drawable entities
de_x        = 0                     de_y =      1
de_w        = 2                     de_h =      3
de_sp_l     = 0 + de_simple_size    de_sp_h =   1 + de_simple_size    

;; Size de DefineDrawableEntity = 6
;; Size de DefineDrawableEntity_Simple = 5

;; 
;;  Funciones Publicas
;;
.globl ren_drawEntity
.globl ren_drawBullet
.globl ren_drawMap
.globl ren_setPalette
.globl ren_getLevelPos
.globl ren_setDrawMap

.globl ren_newScene
.globl ren_clearBackBuffer

.globl ren_setInitialViewport
.globl ren_setInitialMap
.globl ren_addHealthViewport
.globl ren_removeHealthViewport
.globl ren_modifyKeyViewport
.globl ren_addStrengthViewport

